Return-Path: <mailbot@element5.de>
Received: from nls.element5.com (nls.element5.com [217.65.143.242])
	by localhost.localdomain (8.12.11/8.12.8) with SMTP id i47I6UU8005840
	for <support@smoothftp.com>; Fri, 7 May 2004 13:06:31 -0500
Received: (qmail 63546 invoked by uid 0); 7 May 2004 19:27:41 -0000
Received: from unknown (HELO ZAPPA) (192.168.11.2)
  by nls.element5.com with SMTP; 7 May 2004 19:27:41 -0000
Date: Fri, 07 May 2004 21:27:39 +0200
Message-ID: <200405072127400084075084@backoffice.element5.de>
Organization: element 5 AG
From: "share-it! News" <sales@shareit.com>
Subject: share-it! Newsletter - Update on acquisition
Mime-Version: 1.0
Content-Type: text/plain; charset="iso-8859-1"
Content-Disposition: inline
To: "Varghese Eapen" <support@smoothftp.com>

Dear Varghese Eapen,

Two weeks after the acquisition of element 5 and share-it! by Digital 
River, I would like to update you on our integration efforts, future 
plans and the resulting multitude of positive outcomes for our customers. 
We have identified a number of best practices and advantages available 
from the combined organization that will help you grow revenue, extend 
the available services, and increase efficiencies to operate your 
e-commerce.

I assure you that these integration efforts are being carried out at the 
same high-level of quality and diligence that you are used to seeing from 
us, with a clear focus on creating better offerings for our customers. At 
the same time, we view it as absolutely critical to maintain normal 
business and continue enhancing our platform and running our operations, 
and all at the same and improved service levels that you expect. The way 
we structured the integration teams as well as the extensive integration 
experience of the management teams allow us to do that very effectively.

Here is an overview of some of the key benefits you are going to see very 
shortly:


- Gaining access to Digital River's marketing network will provide even 
more opportunities for your sales. Get access to the powerful network of 
marketing partners in the U.S., such as the online stores of Best Buy and 
CompUSA, as well as TBYB sites like PC Magazines, and many more. We are 
working on an automatic data feed in order to support a seamless 
integration of your products into these networks and provide reporting to 
you on a monthly basis.

- Establishing additional Cross-Selling opportunities with software 
publishers from the Digital River network will give you an even greater 
selection for finding complementary product offerings and for launching 
joint marketing programs. In addition, we will identify best practices 
for cross-selling presentation, setup, and rollout in order to increase 
pick rates and shorten implementation times.

- Consolidating and synchronizing Digital River and share-it!'s powerful 
data centers worldwide will provide more redundancy and scalability. You 
will benefit from Digital River's data center in the U.S., where we will 
have a replicated environment of the share-it! technical infrastructure. 
This is designed with the goal of reducing loading times for your 
e-commerce sites hosted on share-it! in North America and Asia/Pacific.

- Combining fraud detection algorithms will allow for more effective 
fraud control. We will be able to match fraud scores against a much larger 
database of historical purchases, thereby securing your sales even more 
against credit card fraud.

- Extending global reach and customer service hours at multiple locations 
around the world will benefit our worldwide customers. It is our goal to 
combine our customer service facilities in order to extend the hours of 
availability, language support, and locations.

- Utilizing Digital River's capabilities, we will be able to make 
additional payment options possible for you in both North America and 
Asia. We will be able to leverage our combined purchasing power in order 
to make additional payment options available more quickly around the 
world.


This is just a sampling of a long list benefits that you will see 
resulting from the combined organization of share-it! and Digital River. 
Many of these advantages are emerging rather quickly, and we want to pass 
them immediately on to you. You can expect frequent updates in the 
future, so that you will know exactly what to expect and when.

Please contact us at any time if you have any questions.

Sincerely,

Gerrit Schumann
CEO
share-it!
