#!/usr/bin/perl

use Net::FTP;
require "wf_read_cookie_data.cgi";
require "read_form_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";

&read_form_data();
&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($FORM{name} eq "")
  {$error = 1;$errmsg = "NAME cannot be empty";}

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  $chmod1 = 0;

  if($FORM{user_rd} eq "on")
    {$chmod1 += 4;} 

  if($FORM{user_wr} eq "on")
    {$chmod1 += 2;} 

  if($FORM{user_ex} eq "on")
    {$chmod1 += 1;} 

  $chmod2 = 0;

  if($FORM{group_rd} eq "on")
    {$chmod2 += 4;} 

  if($FORM{group_wr} eq "on")
    {$chmod2 += 2;} 

  if($FORM{group_ex} eq "on")
    {$chmod2 += 1;} 

  $chmod3 = 0;

  if($FORM{other_rd} eq "on")
    {$chmod3 += 4;} 

  if($FORM{other_wr} eq "on")
    {$chmod3 += 2;} 

  if($FORM{other_ex} eq "on")
    {$chmod3 += 1;} 

  &wf_print_header("SmoothFTP > Chmod",$FORM{servername},"<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>$FORM{cwd}</a>","$FORM{user_id}");

  $ftp = &wf_connect();
  $ftp->cwd($FORM{cwd});

  if($FORM{octal_mode} eq "")
   {$FORM{octal_mode} = "$chmod1$chmod2$chmod3";}

  $ftp->site("CHMOD $FORM{octal_mode} $FORM{name}");
  $msg = $ftp->code . " " . $ftp->message;
  $ftp->quit;

  print "<p align=center><strong><font color=#0080C0 size=4>Chmod</font></strong></p>";

  print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

  print "<tr>";
  print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>Mode</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>Message</strong></td>";
  print "</tr>";

  print "<tr>";
  print "<td>$FORM{name}</td>";
  print "<td>$FORM{octal_mode}</td>";
  print "<td>$msg</td>";
  print "</tr>";

  print "</table>";

  print "<br><p align=center><b><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>Continue</a></b></p>";

  &wf_print_footer(1);
 }
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }

#--- end
