#!/usr/bin/perl

use DBI;

require "wf_print_message.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "read_form_data.cgi";
require "redirect.cgi";

&read_form_data();

if(length($FORM{name}) < 1)
 {
  &wf_print_message("Name cannot be empty");
  exit;
 }

if(length($FORM{email}) < 1)
 {
  &wf_print_message("Email cannot be empty");
  exit;
 }

if(length($FORM{comments}) < 1)
 {
  &wf_print_message("Purpose cannot be empty");
  exit;
 }

@d = localtime;
$key = (($d[5]-1) * 525600) + (($d[4]-1) * 43200) + (($d[3]-1) * 1440) + 
(($d[2]-1) * 60) + $d[1];

open(MAIL,"| /usr/sbin/sendmail -t");

print MAIL "From: SmoothFTP <support\@smoothftp.com>\n";
print MAIL "To: $FORM{email}\n";
print MAIL "BCC: support\@smoothftp.com, sf\@denish.com\n";
print MAIL "Subject: Download of SmoothFTP Beta code ($key)\n\n";

print MAIL "Dear $FORM{name} (@FORM{email}),\n\n";
print MAIL "Thank you for your interest in the SmoothFTP Beta code.\n";
print MAIL "This is what we received as your reason for download:\n\n";
print MAIL "$FORM{comments}\n\n";
print MAIL "Please join the SmoothFTP forum at http://forum.smoothftp.com\n\n";
print MAIL "Kindly note that the Beta code expires on Dec 31st 2002.\n\n";
print MAIL "We look forward to hearing from you at the earliest.\n";

print MAIL "Regards,\n";
print MAIL "-\n";
print MAIL "Support Team\n";
print MAIL "SmoothFTP.com\n\n";
print MAIL "\n\nBrowser info:\n";
print MAIL "Name: $FORM{appname}\n";
print MAIL "Version: $FORM{appvers}\n";
print MAIL "Useragent: $FORM{useragent}\n";

close(MAIL);

&wf_print_header("SmoothFTP > Download","","","");
print <<EOF;

<br><br>
<p align="center">
Please click the link below to download the file:
</p>
<table align=center><tr><td>
<ul>
 <li>Linux (libc6): <a href=/smoothftp-linux.tgz>smoothftp-linux.tgz</a> (approx 8 MB)</li>
 <li>Linux (libc5): <a href=/smoothftp-linux-glibc5.tgz>smoothftp-linux-glibc5.tgz</a> (approx 8 MB)</li>

<!-- 
 <li>SunOS: <a href=/smoothftp-sunos-1.0.tgz>smoothftp-sunos-1.0.tgz</a></li>
 <li>HP-UX: <a href=/smoothftp-hpux-1.0.tgz>smoothftp-hpux-1.0.tgz</a></li>
 <li>BSDOS: <a href=/smoothftp-bsdos-1.0.tgz>smoothftp-bsdos-1.0.tgz</a></li>
 <li>IRIX: <a href=/smoothftp-irix-1.0.tgz>smoothftp-irix-1.0.tgz</a></li>
 <li>FreeBSD: <a href=/smoothftp-freebsd-1.0.tgz>smoothftp-freebsd-1.0.tgz</a></li>
 <li>MIPS Linux: <a href=/smoothftp-linux-mips-1.0.tgz>smoothftp-linux-mips-1.0.tgz</a></li>
 <li>OpenBSD: <a href=/smoothftp-openbsd-1.0.tgz>smoothftp-openbsd-1.0.tgz</a></li> -->
</ul>
</tr></td></table>
<p align="center">
<a href=/>Continue</a>
</p>

EOF

&wf_print_footer();
