#!/usr/bin/perl

use Net::FTP;
require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";
require "get_recursive.cgi";
require "read_config.cgi";

&wf_read_cookie_data();

#--- read form values manually

$recursive = "";

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$count = -1;
$dircount = -1;
foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

  $FORM{$name} = $value;
#  print "$name, $value<br>";

  if($name eq "name")
   {$FILES[++$count] = $value;}
  elsif($name eq "type")
   {
    $FTYPES[$count] = $value;
    $NDIRS[++$dircount] = $value if($value eq "D");
   }
  elsif($name eq "mode")
   {$mode[$count] = $value;}
  elsif($name eq "recursive")
   {$recursive = $value;}
#  elsif($name eq "uw")
#   {$uw[$count] = $value;}
#  elsif($name eq "ux")
#   {$ux[$count] = $value;}
#  elsif($name eq "gr")
#   {$gr[$count] = $value;}
#  elsif($name eq "gw")
#   {$gw[$count] = $value;}
#  elsif($name eq "gx")
#   {$gx[$count] = $value;}
#  elsif($name eq "or")
#   {$or[$count] = $value;}
#  elsif($name eq "ow")
#   {$ow[$count] = $value;}
#  elsif($name eq "ox")
#   {$ox[$count] = $value;}
 }

#--- error handling

&read_config();

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($count == -1)
  {$error = 1;$errmsg = "NAMES cannot be empty";}

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  $ftp = &wf_connect();
  $ftp->cwd($FORM{cwd});
  &get_recursive() if($recursive eq "on");
  $ftp->cwd($FORM{cwd}) if($recursive eq "on");

  $errors = 0;
  for($i = 0;$i <= $#FILES;$i++)
   {
    next if($FTYPES[$i] eq "X");
 
    $which = $i;
    $which = 0 if($FORM{chmodtype} eq "all" or $count == 0);

#    $chmod1 = 0;

#    if($ur[$which] eq "on")
#      {$chmod1 += 4;} 

#    if($uw[$which] eq "on")
#      {$chmod1 += 2;} 

#    if($ux[$which] eq "on")
#      {$chmod1 += 1;} 

#    $chmod2 = 0;

#    if($gr[$which] eq "on")
#      {$chmod2 += 4;} 

#    if($gw[$which] eq "on")
#      {$chmod2 += 2;} 

#    if($gx[$which] eq "on")
#      {$chmod2 += 1;} 

#    $chmod3 = 0;

#    if($or[$which] eq "on")
#      {$chmod3 += 4;} 

#    if($ow[$which] eq "on")
#      {$chmod3 += 2;} 

#    if($ox[$which] eq "on")
#      {$chmod3 += 1;} 

    $chm = $mode[$which];
 
    if($chm eq "")
     {
      $msg[$i] = "<font color=red>MODE is empty</font>";
      $errors++;
     }
    else
     {
      $ftp->site("CHMOD $chm $FILES[$i]");
      if($ftp->ok)
       {
        $msg[$i] = $ftp->code . " " . $ftp->message;
       }
      else
       {
        $msg[$i] = "<font color=red>" . $ftp->code . " " . $ftp->message . "</font>";
        $errors++;
       }
      }
   }

  $ftp->quit;

  if($errors > 0)
   {
    &wf_print_header("SmoothFTP > Chmod",$FORM{servername},"<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>$FORM{cwd}</a>","$FORM{user_id}");

    print "<p align=center><span class=headings>Chmod</span></p>";
  
#    print "<br><p align=center><b><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>Continue</a></b></p>";

    print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

    print "<tr>";
    print "<td class=darkshadebold>Name</td>";
    print "<td class=darkshadebold>Mode</td>";
    print "<td class=darkshadebold>Message</td>";
    print "</tr>";

    for($i = 0;$i <= $#FILES;$i++)
     {
       $which = $i;
       $which = 0 if($FORM{chmodtype} eq "all" or $count == 0);

       next if($FTYPES[$i] eq "X");
       print "<tr>";
       print "<td>$FILES[$i]</td>";
       print "<td>$mode[$which]</td>";
       print "<td>$msg[$i]</td>";
       print "</tr>";
     }

    print "</table>";

    print "<br><p align=center><span class=boldlink><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>Continue</a></span></p>";

    &wf_print_footer(1);
   }
  else
   {
    &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}&msgok=Chmod");
   }
 }
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }

#--- end
