#!/usr/bin/perl

use Net::FTP;
use DBI;

require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";
require "get_recursive.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$fcount = -1;
$madder = -1;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "name")
   {$FILES[++$fcount] = $value;
    $FTYPES[$fcount] = "F";
   }
  elsif($name eq "dname")
   {
    $FILES[++$fcount] = $value;
    $FTYPES[$fcount] = "D";
    $NDIRS[++$madder] = $value;
   }
  else
   {$FORM{$name} = $value;}
 }

#--- read cookies

&wf_read_cookie_data();

@cookies = split("; ",$ENV{'HTTP_COOKIE'});

$FORM{smoothftp_user} = "-1";

for($i = 0;$i <= $#cookies;$i++)
 {
  ($cookie,$value) = split("=",$cookies[$i]);
    if($cookie eq "SMOOTHFTP_USR")
     {$FORM{smoothftp_user} = $value;}
    if($cookie eq "SMOOTHFTP_REM")
     {$FORM{smoothftp_rem} = $value;}
 }

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($fcount < 0)
  {$error = 1;$errmsg = "NAME cannot be empty";}

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  &wf_print_header("SmoothFTP > Download",$FORM{servername},"<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\">$FORM{cwd}</a>","$FORM{user_id}",0,"onLoad=\"UploadClose();\"");

  $random = rand 65365;
  $random = "tmp/$random";
  system("/bin/mkdir \"/home/websites/smoothftp_com/downloads/$random\"");
  system("/bin/echo rm -rf \"/home/websites/smoothftp_com/downloads/$random\" | /usr/bin/at now + 3 hours");
  system("/bin/mkdir \"/home/websites/smoothftp_com/downloads/$random/files\"");

  $totaldownsz = 0;
  $errors = 0;

 # $db = DBI->connect("dbi:mysql:database=smoothftp","denish","ebilfadi75");

  $donefiles = 0;
  $ftp = &wf_connect();

  $ftp->cwd($FORM{cwd});

  &get_recursive();

  $ftp->cwd($FORM{cwd});

  foreach $entry (@NDIRS)
   {system("/bin/mkdir \"/home/websites/smoothftp_com/downloads/$random/files/$entry\"");}

  for($i = 0;$i <= $#FILES;$i++)
   {
    $downmsg[$i] = $FTYPES[$i];
    $downsz[$i] = "&nbsp;";
    $downlink[$i] = "Not Available";

    if($FTYPES[$i] ne "D")
     {
#      if(index($FILES[$i],"/") > 0)
#        {
#          @temp = split("/",$FILES[$i]);
#          $localfn =  "$temp[$#temp]";
#        }
#      else
#        {$localfn = "$FILES[$i]";}

      $localfn = $FILES[$i];
#      $localfn =~ tr [ ] [_];

      $fname = "/home/websites/smoothftp_com/downloads/$random/files/$localfn";

      $upper_limit = 51200;
      $upper_limit = 999999999 if(length($FORM{smoothftp_user}) gt 2);

      $remot_sz = $ftp->size($FILES[$i]);

      if($remot_sz <= $upper_limit)
       {
        $ftp->binary();
        $ftp->get("$FILES[$i]","$fname");

        $msg = $ftp->code . " " . $ftp->message;
        $msg =~ s/ASCII mode data/data/g;
        $msg =~ s/BINARY mode data/data/g;
       }

      if($remot_sz <= $upper_limit and $ftp->ok)
        {
          open(WORK,"$fname");
          @d = stat(WORK);
          $filesize = $d[7];
          close(WORK);

          @d = localtime;
#          $query = "insert into download_traffic(timestamp,month,ftpserver,filename,filesize,localname,userid) values ('@d',$d[4],'$FORM{servername}','$FORM{cwd}/$FILES[$i]',$filesize,'$random/files/$localfn','$FORM{user_id}')";
#          $db->do($query) or &wf_print_message($query . $db->errstr);
#          $db->do($query);

          $size_kb = 0;
          $size_mb = 0;

          if($filesize > 1024)
            {
             $size_kb = $filesize / 1024;
             if($size_kb > 1024)
              {$size_mb = $size_kb / 1024;
               $filesz = sprintf("%7.2f",$size_mb) . " mb";}
             else
              {$filesz = sprintf("%d",$size_kb) . " kb";}
            }
          else
            {$filesz = sprintf("%d bytes",$filesize);}

          if($filesize <= $upper_limit)
           {
            $totaldownsz += $filesize;
            $donefiles++;

            $downmsg[$i] = "<img src=/images/downloading.gif width=13 height=12 name=imgdownld$i>";
            $downsz[$i] = $filesz;
            $downlink[$i] = "<input type=button style=\"font-family:arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=downld value=Download onclick='window.location.href=\"/cgi-bin/smoothftp/wf_getfile.cgi/$random/files/$localfn\";'>";
           }
          else
           {
            system("rm /home/websites/smoothftp_com/downloads/$random/files/$localfn;");
            $downmsg[$i] = "<font color=red>Please limit file sizes to $upper_limit bytes</font> or <a href=/cgi-bin/secure/wf_signup.cgi>SignUp</a> for paid service.";
            $downsz[$i] = "&nbsp;";
            $downlink[$i] = "Not Available";
            $errors++;
           }
        }
      else
        {
          if($remot_sz <= $upper_limit)
           {
            $downmsg[$i] = $msg;
            $downsz[$i] = "&nbsp;";
            $downlink[$i] = "Not Available";
           }
          else
           {
            $downmsg[$i] = "<font color=red>Please limit file sizes to $upper_limit bytes</font> or <a href=/cgi-bin/secure/wf_signup.cgi>SignUp</a> for paid service.";
            $downsz[$i] = "&nbsp;";
            $downlink[$i] = "Not Available";
           }
          $errors++;
        }
     }
   }
  $ftp->quit;
#  $db->disconnect;

  $filesize = $totaldownsz;
  if($filesize > 1024)
    {
     $size_kb = $filesize / 1024;
     if($size_kb > 1024)
      {$size_mb = $size_kb / 1024;
       $filesz = sprintf("%7.2f",$size_mb) . " mb";}
     else
      {$filesz = sprintf("%d",$size_kb) . " kb";}
    }
  else
    {$filesz = sprintf("%d bytes",$filesize);}

  print "<form name=down_form>";


  print "<p align=center><strong><font color=#0080C0 size=4>Download</font></strong></p>";
  print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

  if($errors > 0)
   {
    print "<tr>";
    print "<td colspan=4 align=center><font color=red>Errors encountered. Please see details below.</font></td>";
    print "</tr>";
   }

  print "<tr>";
  print "\n<font color=white>test: /home/websites/smoothftp_com/downloads/$random/files/$localfn  </font>\n";
  print "<td colspan=3 bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td align=left bgcolor=#EEEEEE><strong>Action</strong></td>";
  print "</tr>";

  $ftcount = $fcount + 1;
  print <<Eof;
<script language=javascript>
<!--

  function UploadClose()
    {
if (document.getElementById)
   {
   document.getElementById('myLayer').style.visibility = 'hidden';
   } 
else if (document.all)
   {
   document.all['myLayer'].style.visibility = 'hidden';
   }
else if (document.layers)
   {
   document.layers['myLayer'].visibility = 'hide';
   }
}

  function handle_down()
    {
      x = document.down_form.ziptype.selectedIndex;
      zt = document.down_form.ziptype.options[x].text;
      
      if(x == 0)
        {alert("Please choose the type of archive");}
      else
        {
          if(document.down_form.zipname.value.length == 0)
            {alert("Please enter a file name for the archive");}
          else
            {
              if(zt == 'ZIP file')
                {
//       document.down_form.imgdownldall.src='/images/okayz.gif';
                 window.location.href = '/cgi-bin/smoothftp/wf_getfilez.cgi/$random/' +document.down_form.zipname.value+'.zip';
                }
              else
                {
//                 document.down_form.imgdownldall.src='/images/okayz.gif';
                 if(zt == 'Windows self-extracting program file')
                  {ext = ".exe";typ = 'windows';}
                 if(zt == 'Linux self-extracting file')
                  {ext = ".sfx";typ = 'linux';}
                 if(zt == 'FreeBSD self-extracting file')
                  {ext = ".sfx";typ = 'freebsd';}
                 if(zt == 'Solaris self-extracting file')
                  {ext = ".sfx";typ = 'solaris';}
                 if(zt == 'HP Unix self-extracting file')
                  {ext = ".sfx";typ = 'hp';}
                 if(zt == 'AIX self-extracting file')
                  {ext = ".sfx";typ = 'aix';}
                 if(zt == 'SGI UNIX self-extracting file')
                  {ext = ".sfx";typ = 'sgi';}
                 if(zt == 'OS/2 self-extracting .exe file')
                  {ext = ".exe";typ = 'os2';}

                 window.location.href = '/cgi-bin/smoothftp/wf_getfileze.cgi/$random/'+typ+'/'+document.down_form.zipname.value+ext;
                }
            }
        }
    }
// -->
</script>

Eof





  if($donefiles > 0)
   {
    print "<tr><td colspan=2>";
    print "Download the files as a compressed archive:";
    print "</td></tr>";

    print "<tr>";
    print "<td colspan=2>File Name: <input type=text name=zipname length=20 maxlength=20 value=download></td>";
    print "<td align=center><img src=/images/downloadingz.gif width=17 height=15 name=imgdownldall></td>";
    print "<td align=left>";
    print "<select name=ziptype size=1>";
    print "<option value=nil>Choose type of archive...</option>";
    print "<option value=zip>ZIP file</option>";
    print "<option value=windows>Windows self-extracting program file</option>";
    print "<option value=linux>Linux self-extracting file</option>";
    print "<option value=freebsd>FreeBSD self-extracting file</option>";
    print "<option value=solaris>Solaris self-extracting file</option>";
    print "<option value=dec>DEC Unix self-extracting file</option>";
    print "<option value=hp>HP Unix self-extracting file</option>";
    print "<option value=aix>AIX self-extracting file</option>";
    print "<option value=sgi>SGI Unix self-extracting file</option>";
    print "<option value=os2>OS/2 self-extracting .exe file</option>";
    print "</select>&nbsp; ";
    print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=downld value='Download' onclick='handle_down();'>";
    print "</td>";
    print "</tr>";

    print "<tr><td colspan=4 align=center>";
    print "<br><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\"><b>Continue</b></a>";
    print "</td></tr>";

    print "<tr><td colspan=2>";
    print "Download the files individually:";
    print "</td></tr>";
  }

  for($i = 0;$i <= $#FILES;$i++)
   {
    if($FTYPES[$i] ne "D")
     {
      print "<tr>";
      print "<td><img src=/images/file.gif height=12 width=13>&nbsp;$FILES[$i]</td>";
      if($downlink[$i] ne "Not Available")
       {
        print "<td align=right>$downsz[$i]</td>";
        print "<td align=center>$downmsg[$i]</td>";
        print "<td align=left>$downlink[$i]</td>";
       }
      else
       {
        print "<td align=right>&nbsp;</td>";
        print "<td align=center>&nbsp;</td>";
        print "<td align=left>$downmsg[$i]</td>";
       }

      print "</tr>";
     }
   }

  print "</table>";

  print "<br><p align=center><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\"><b>Continue</b></a></p>";
  print "</form>";

#  print "<p align=center><b>Note:</b> In some versions of IE (we know about 5.5), you may face issues while downloading files. In these cases, when you click on the 'Download' button and if you are prompted to 'Open' or 'Save' the file <b>'download.htm'</b>, choose 'Open' and you will then be prompted once again to 'Open' or 'Save': this time, choose 'Save' to get your file.</p>";

  &wf_print_footer(1);
 }
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }

#--- end
