#!/usr/bin/perl

use Net::FTP;
require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$fcount = -1;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "name")
   {$OLD_NAME[++$fcount] = $value;}
  elsif($name eq "new_name")
   {$NEW_NAME[$fcount] = $value;}
  else
   {$FORM{$name} = $value;}
 }

#--- read cookies

&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($fcount < 0)
  {$error = 1;$errmsg = "NAME cannot be empty";}

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  $found_errors = 0;

  $ftp = &wf_connect();
  $ftp->cwd($FORM{cwd});
  for($i = 0;$i <= $fcount;$i++)
   {
    if($NEW_NAME[$i] ne "" and $OLD_NAME[$i] ne $NEW_NAME[$i])
     {
#      $NEW_NAME =~ tr [ ] [_];

      $doit = 1;
      $doit = 0 if($ftp->size($NEW_NAME[$i]) > 0);

      if($doit == 1)
       {
        $ftp->rename("$OLD_NAME[$i]","$NEW_NAME[$i]");
        $renmsg[$i] =  $ftp->code . " " . $ftp->message;
        if($ftp->ok)
         {$upokay[$i] = 1;}
        else
         {$upokay[$i] = 0; $found_errors = 1;}
       }
      else
       {$renmsg[$i] =  "SKIPPED. Destination file already exists.";$upokay[$i] = 0; $found_errors = 1;}
     }
    else
     {$renmsg[$i] =  "SKIPPED";$upokay[$i] = 1; $found_errors = 1;}
   }
  $ftp->quit;

  if($found_errors == 1)
   {
    &wf_print_header("SmoothFTP > Rename confirmation",$FORM{servername},"<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\">$FORM{cwd}</a>","$FORM{user_id}");

    print "<p align=center><strong><font color=#0080C0 size=4>Rename Messages</font></strong></p>";

    print "<p align=center><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\"><b>Continue</b></a></p>";

    print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

    print "<tr>";
    print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
    print "<td bgcolor=#EEEEEE><strong>New name</strong></td>";
    print "<td bgcolor=#EEEEEE><strong>Message</strong></td>";
    print "</tr>";
 
    for($i = 0;$i <= $fcount;$i++)
     {
      $fs = "";
      $fe = "";

      $fs = "<font color=red>" if($upokay[$i] ne 1);
      $fe = "</font>" if($upokay[$i] ne 1);

      print "<tr>";
  
      print "<td>$OLD_NAME[$i]</td>";

      if($NEW_NAME[$i] ne "" and $OLD_NAME[$i] ne $NEW_NAME[$i])
       {
        print "<td>$NEW_NAME[$i]</td>";
        print "<td>$fs $renmsg[$i] $fe</td>";
       }
      else
       {
        print "<td colspan=2>$fs $renmsg[$i] $fe</td>";
       }
      print "</tr>";
     }
 
    print "</table>";

    print "<br><p align=center><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\"><b>Continue</b></a></p>";

    &wf_print_footer(1);
   } 
  else
   {
    &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}&msgok=Rename");
   }
}
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }
