#!/usr/bin/perl

use DBI;

require "wf_print_message.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "read_form_data.cgi";
require "redirect.cgi";

&read_form_data();

if(length($FORM{ftpserver}) < 1)
 {
  &wf_print_message("FTP server cannot be empty");
  exit;
 }

if(length($FORM{port}) < 1)
 {
  &wf_print_message("Port cannot be empty");
  exit;
 }

if($FORM{ftpserver} eq "localhost")
 {
  &wf_print_message("Cannot use <b>localhost</b> as FTP server name");
  exit;
 }

$l = length($FORM{ftpserver});

$alpha = 0;
$numb = 0;
for($i = 0;$i < $l;$i++)
 {
  $okay = 0;
  $uname = substr $FORM{ftpserver},$i,1;
  $a = ord $uname;
  if($a >= 65 and $a <= 65+26){$okay = 1; $alpha++;}
  if($a >= 97 and $a <= 97+26){$okay = 1; $alpha++;}
  if($a >= 48 and $a <= 48+10){$okay = 1; $numb++;}
  if($uname eq "_"){$okay = 1;}
  if($uname eq "."){$okay = 1;}
  if($okay == 0)
    {
     &wf_print_message("<b>$FORM{ftpserver}</b> : FTP server can be made up of alphabets, numbers & underscore only.");
     exit;
    }
 }

if($alpha == 0)
 {
  &wf_print_message("<b>$FORM{ftpserver}</b> Please enter server name and not IP address (need atleast one alphabet).");
  exit;
 }

@d = localtime;
$key = (($d[5]-1) * 525600) + (($d[4]-1) * 43200) + (($d[3]-1) * 1440) + 
(($d[2]-1) * 60) + $d[1];

#open(MAIL,"| /usr/sbin/sendmail -t");

#print MAIL "From: SmoothFTP <support\@smoothftp.com>\n";
#print MAIL "To: $FORM{email}\n";
#print MAIL "BCC: support\@smoothftp.com, sf\@denish.com\n";
#print MAIL "Subject: Download of SmoothFTP Beta code ($key)\n\n";

#print MAIL "Dear $FORM{name} (@FORM{email}),\n\n";
#print MAIL "Thank you for your interest in the SmoothFTP Beta code.\n";
#print MAIL "This is what we received as your reason for download:\n\n";

#print MAIL "Regards,\n";
#print MAIL "-\n";
#print MAIL "Support Team\n";
#print MAIL "SmoothFTP.com\n\n";

#close(MAIL);

&wf_print_header("SmoothFTP > Customize","","","");

print "<table align=center>";
print "<tr><td align=center><strong><font color=#0080C0 size=4>Customize</font></strong></td> </tr>";
print "<tr><td><br><br>Customizing for <b>$FORM{ftpserver}:$FORM{port}...</b><br><br>";
print "</td></tr>";



print <<EOF;

<!-- <tr><td>
 Click to download <a href=/smoothftp-linux.tgz>smoothftp-linux.tgz</a> (approx 8 MB)
</tr></td>
-->

</table>
<p align="center">
<a href=/>Continue</a>
</p>

EOF

&wf_print_footer();
