#!/usr/bin/perl

use Net::FTP;
require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$fcount = -1;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "name")
   {$FOLDERS[++$fcount] = $value;}
  else
   {$FORM{$name} = $value;}
 }

#--- read cookies

&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($fcount < 0)
  {$error = 1;$errmsg = "NAME cannot be empty";}

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  &wf_print_header("SmoothFTP > Remove Directory",$FORM{servername},"<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>$FORM{cwd}</a>","$FORM{user_id}");

  $ftp = &wf_connect();
  $ftp->cwd($FORM{cwd});
  for($i = 0;$i <= $fcount;$i++)
   {
    $ftp->rmdir($FOLDERS[$i]);
    $rmdmsg[$i] = $ftp->code . " " . $ftp->message;
   }
  $ftp->quit;

  print "<p align=center><strong><font color=#0080C0 size=4>Remove Directory</font></strong></p>";

  print "<p align=center><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}><b>Continue</b></a></p>";

  print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

  print "<tr>";
  print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>Message</strong></td>";
  print "</tr>";

  for($i = 0;$i <= $fcount;$i++)
   {
    print "<tr>";
  
    print "<td><img src=/images/folder.gif height=12 width=13>&nbsp;$FOLDERS[$i]</td>";
    print "<td>$rmdmsg[$i]</td>";
    print "</tr>";
   }

  print "</table>";

  print "<br><p align=center><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}><b>Continue</b></a></p>";

  &wf_print_footer(1);
 }
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }

#--- end
