#!/usr/bin/perl

use DBI;

require "wf_print_message.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "read_form_data.cgi";
require "redirect.cgi";

&read_form_data();

if(length($FORM{name}) < 1)
 {
  &wf_print_message("Name cannot be empty");
  exit;
 }

if(length($FORM{email}) < 1)
 {
  &wf_print_message("Email cannot be empty");
  exit;
 }

if(length($FORM{comments}) < 1)
 {
  &wf_print_message("Comments cannot be empty");
  exit;
 }

@d = localtime;
$key = (($d[5]-1) * 525600) + (($d[4]-1) * 43200) + (($d[3]-1) * 1440) + 
(($d[2]-1) * 60) + $d[1];

open(MAIL,"| /usr/sbin/sendmail -t");

print MAIL "From: SmoothFTP <support\@smoothftp.com>\n";
print MAIL "To: $FORM{email}\n";
print MAIL "BCC: support\@smoothftp.com, sf\@denish.com\n";
print MAIL "Subject: Your comments on SmoothFTP.com ($key)\n\n";

print MAIL "Dear $FORM{name} (@FORM{email}),\n\n";
print MAIL "Thank you for your comments. This is what we received:\n\n";
print MAIL "$FORM{comments}\n\n";
print MAIL "We will get back to you at the earliest.\n";

print MAIL "Regards,\n";
print MAIL "-\n";
print MAIL "Support Team\n";
print MAIL "SmoothFTP.com\n\n";
print MAIL "\n\nBrowser info:\n";
print MAIL "Name: $FORM{appname}\n";
print MAIL "Version: $FORM{appvers}\n";
print MAIL "Useragent: $FORM{useragent}\n";

close(MAIL);

&wf_print_header("SmoothFTP > Contact us","","","");
print <<EOF;

<br><br>
<p align="center">
Thank you for your comments.
</p>
<p align="center">
<a href=/>Continue</a>
</p>

EOF

&wf_print_footer();
