#!/usr/bin/perl

sub get_recursive
 {
  $adder = $#FILES;
  $madder = $#NDIRS;

  for($ti = 0;$ti <= $adder;$ti++)
   {
    $entry = $FILES[$ti];
    $type = $FTYPES[$ti];
#    print "Checking $entry,$type<br>";

    if($type eq "D")
     {
      @tdir = "";
      @name = "";
      @tdir = $ftp->dir($entry);

#     print "Checking $#tdir:<br>";

      $rl = -1;
      $didit = 0;
      for($i = 0,$k = 0;$i <= $#tdir;$i++,$k++)
       {
#        print "$tdir[$i]<br>";

        @workbuff = split(" ",$tdir[$i]);

        $attrib[$k] = $workbuff[0];

        if(substr($attrib[$k],0,1) ne "d" and substr($attrib[$k],0,1) ne "l" and substr($attrib[$k],0,1) ne "-")
         {$k--;} ## discard all entries except directories, links and normal files
        else
         {
          $didit = 1;
          if(substr($attrib[$k],0,1) eq "l")  ## is a link
           {
            $name[$k] = $workbuff[$#workbuff-2];
            $actual_name[$k] = $workbuff[$#workbuff];
            $actual_attrib[$k] = "-";
            $is_link[$k] = 1;
            $resolve_links[++$rl] = $k;
           }
          else                               ## is not a link
           {
            $name[$k] = $workbuff[$#workbuff];
            $actual_name[$k] = $name[$k];
            $actual_attrib[$k] = $attrib[$k];
            $is_link[$k] = 0;
           }
         }
       }

      #- resolve links in array

      for($i = 0;$i <= $rl;$i++)
       {
        $j = rindex $actual_name[$resolve_links[$i]],"/";
        $l = length $actual_name[$resolve_links[$i]];

        if($j > 0) ## links to entry in another directory
         {
          $resolve_path = substr $actual_name[$resolve_links[$i]],0,$j;
          $resolve_check = substr $actual_name[$resolve_links[$i]],$j+1,$l-$j;

          @wdir = $ftp->dir($resolve_path);
          for($j = 0;$j <= $#wdir;$j++)
           {
            @workbuff = split(" ",$wdir[$j]);
            if($resolve_check eq $workbuff[$#workbuff])
             {$actual_attrib[$resolve_links[$i]] = $workbuff[0];}
           }
         }
        else      ## links to entry in current dir
         {
          for($j = 0;$j <= $#tdir;$j++)
           {
            if($actual_name[$resolve_links[$i]] eq $name[$j])
             {$actual_attrib[$resolve_links[$i]] = $attrib[$j];}
           }
         }
       }
      if($didit != 0)
       {
        for($i = 0;$i <= $#name;$i++)
         {
          if(substr($name[$i],0,1) ne "." and $name[$i] ne "")  ## file not hidden & name not empty
           {
#             print "Adding $name[$i],$i<br>";
             if(substr($attrib[$i],0,1) eq "d")
              {
               $FILES[++$adder] = $FILES[$ti]."/".$name[$i];
               $FTYPES[$adder] = "D";
               $NDIRS[++$madder] = $FILES[$ti]."/".$name[$i];
              }
             if(substr($attrib[$i],0,1) ne "d")
              {
               $FILES[++$adder] = $FILES[$ti]."/".$name[$i];
               $FTYPES[$adder] = "F";
              }
           }
         }
       }
     }
   }
 }
1;
