#!/usr/bin/perl

use Net::FTP;
require "read_form_data.cgi";
require "wf_read_cookie_data.cgi";
require "wf_connect.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "wf_print_toolbar.cgi";

&read_form_data();
&wf_read_cookie_data();

$ftp = &wf_connect();
$home_dir = $ftp->pwd;

if($FORM{cd} ne "~")
 {
  $ftp->cwd($FORM{cd});
  $code = $ftp->code;
  $msg = $ftp->code . " " . $ftp->message;
  if(! $ftp->ok)
   {
    $ftp->quit;
    &wf_print_message("$FORM{cd} : $msg<br><br><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=~&page=1><b>Home</b></a>",$FORM{servername},$FORM{user_id});
    exit;
   }
 }

if($FORM{action} eq "cdup")
 {$ftp->cdup;}

if($FORM{action} eq "cd")
 {
  $ftp->cwd($FORM{dirname});
  $code = $ftp->code;
  $msg = $ftp->code . " " . $ftp->message;
  if(! $ftp->ok)
   {
    $ftp->quit;
    &wf_print_message("$FORM{dirname} : $msg<br><br><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cd}&page=1><b>Continue</b></a>",$FORM{servername},$FORM{user_id});
    exit;
   }
 }

if($FORM{page} != 0)
 {
  print "Set-Cookie: SMOOTHFTP_PAGE=$FORM{page};\n";
  $page = $FORM{page};
 }
else
 {
  $page = $FORM{pageno}; ## read from cookie
 }

if(length($FORM{actionstyle}) != 0)
 {
  print "Set-Cookie: SMOOTHFTP_ACTIONSTYLE=$FORM{actionstyle};\n";
  $action_style = $FORM{actionstyle};
 }
else
 {
  $action_style = $FORM{action_style}; ## read from cookie
 }

if(length($FORM{dirstyle}) != 0)
 {
  print "Set-Cookie: SMOOTHFTP_DIRSTYLE=$FORM{dirstyle};\n";
  $dir_style = $FORM{dirstyle};
 }
else
 {
  $dir_style = $FORM{dir_style}; ## read from cookie
 }


#--- get listing in array

$cwd = $ftp->pwd;
$showm = 0;

if($cwd eq "/")
 {$fullpath = "";}
else
 {$fullpath = $cwd;}

@dir = $ftp->dir($FORM{filter}) if(length($FORM{filter}) > 0);
@dir = $ftp->dir() if(length($FORM{filter}) == 0);

$outstr = "";

$rl = -1;
for($i = 0,$k = 0;$i <= $#dir;$i++,$k++)
 {
  @workbuff = split(" ",$dir[$i]);

  $attrib[$k] = $workbuff[0];

  $skipit = 0;
  if(length($FORM{filter}) == 0)  ## no filter
   {
    if(substr($attrib[$k],0,1) ne "d" and substr($attrib[$k],0,1) ne "l" and substr($attrib[$k],0,1) ne "-")
     {$skipit = 1;} ## discard all entries except directories, links and normal files
   }
  else ## has filter
   {
    if(substr($attrib[$k],0,1) ne "l" and substr($attrib[$k],0,1) ne "-")
     {$skipit = 1;} ## discard all entries except links and normal files (i.e. discard directories also)
   }
  
  if($skipit == 1)
   {$k--;} 
  else
   {
    $user[$k] = $workbuff[2];
    $group[$k] = $workbuff[3];
    $size[$k] = $workbuff[4];

    if(substr($attrib[$k],0,1) eq "l")  ## is a link
     {
      $name[$k] = $workbuff[$#workbuff-2];

      for($j = 5;$j <= $#workbuff-3;$j++)
       {$date[$k] = $date[$k] . $workbuff[$j] . " ";}

      $actual_name[$k] = $workbuff[$#workbuff];
      $actual_attrib[$k] = "-";
      $is_link[$k] = 1;
      $resolve_links[++$rl] = $k;
     }
    else                               ## is not a link
     {
      $name[$k] = $workbuff[$#workbuff];

      for($j = 5;$j <= $#workbuff-1;$j++)
       {$date[$k] = $date[$k] . $workbuff[$j] . " ";}

      $actual_name[$k] = $name[$k];
      $actual_attrib[$k] = $attrib[$k];
      $is_link[$k] = 0;
     }

    $an = lc $name[$k];
#    $ch = substr $an,0,6;

    if(($an eq ".message" or $an eq "welcome.msg" or $an eq "readme") and $page == 1)
      {
        $random = rand 65365;
        $ftp->get($actual_name[$k],"$FORM{download_dir}/tmp/$random.msg");
        open(WORK,"$FORM{download_dir}/tmp/$random.msg");
        @sh = <WORK>;
        close(WORK);
        for($jj = 0,$kk = $showm;$jj <= $#sh;$jj++,$kk++)
         {$showmsg[$kk] = $sh[$jj];}
        $showm = $kk;
        system("$FORM{cmd_rm} $FORM{download_dir}/tmp/$random.msg");
      }
   }

   if(length($FORM{filter}) > 0 and substr($actual_attrib[$k],0,1) eq "d") ## filter is on & is a directory - so ignore
   {
    $k--;
    $outstr .= "Skipping $actual_name[$k]<br>";
   }
 }

#- resolve links in array

for($i = 0;$i <= $rl;$i++)
 {
  $j = rindex $actual_name[$resolve_links[$i]],"/";
  $l = length $actual_name[$resolve_links[$i]];

  if($j > 0) ## links to entry in another directory
   {
    $resolve_path = substr $actual_name[$resolve_links[$i]],0,$j;
    $resolve_check = substr $actual_name[$resolve_links[$i]],$j+1,$l-$j;

    @wdir = $ftp->dir($resolve_path);
    for($j = 0;$j <= $#wdir;$j++)
     {
      @workbuff = split(" ",$wdir[$j]);
      if($resolve_check eq $workbuff[$#workbuff])
       {$actual_attrib[$resolve_links[$i]] = $workbuff[0];}
     }
   }
  else      ## links to entry in current dir
   {
    for($j = 0;$j <= $#dir;$j++)
     {
      if($actual_name[$resolve_links[$i]] eq $name[$j])
       {$actual_attrib[$resolve_links[$i]] = $attrib[$j];}
     }
   }
 }

$ftp->quit;

#--- print out listing

if($cwd ne "/")
 {
  @levels = split("/",$cwd);
  $send_string = "";
  $url_string = "";
  for($i = 1;$i <= $#levels;$i++)
   {
    $send_string = $send_string . "/" . $levels[$i];
    if($i < $#levels)
     {$url_string = $url_string . "/<a title=\"Change to $send_string\" href=/cgi-bin/smoothftp/wf_list.cgi?cd=$send_string&page=1>$levels[$i]</a>";}
    else
     {$url_string = $url_string . "/$levels[$i]";}
   }
 $url2_string = $cwd;
 }
else
 {
  $url_string = "/";
  $url2_string = "/";
 }

if($#showmsg > 0)
{
  system("$FORM{cmd_echo} $FORM{cmd_rm_force_dir} $FORM{download_dir}/tmp/$random.html | $FORM{cmd_cleanup}");
  open(WORK,"> $FORM{download_dir}/tmp/$random.html");
  print WORK "<html><head><title>SmoothFTP > Server Message : $FORM{server_name}</title><body><pre>\n";
  for($i = 0;$i <= $#showmsg;$i++)
   {print WORK $showmsg[$i];}
  print WORK "</pre></body></html>";
  close(WORK);

#  &wf_print_header("SmoothFTP > $cwd",$FORM{servername},$url2_string,"$FORM{user_id}",1,"onLoad=\"OpenandClose()\"") if($FORM{msgok} eq "Upload");
  &wf_print_header("SmoothFTP > $cwd",$FORM{servername},$url2_string,"$FORM{user_id}",1,"onLoad=\"UploadClose(); window.open('/downloads/tmp/$random.html','msg','width=400,height=350,toolbar=no,resizable=yes,scrollbars=yes');\"") if($FORM{msgok} eq "Upload");
  &wf_print_header("SmoothFTP > $cwd",$FORM{servername},$url2_string,"$FORM{user_id}",1,"onLoad=window.open('/downloads/tmp/$random.html','msg','width=400,height=350,toolbar=no,resizable=yes,scrollbars=yes');") if($FORM{msgok} ne "Upload");
}
else
{
 &wf_print_header("SmoothFTP > $cwd",$FORM{servername},$url2_string,"$FORM{user_id}",1,"onLoad=\"UploadClose();\"") if($FORM{msgok} eq "Upload");
 &wf_print_header("SmoothFTP > $cwd",$FORM{servername},$url2_string,"$FORM{user_id}",1) if($FORM{msgok} ne "Upload");
 }

&wf_print_toolbar($cwd,$home_dir,"BUTTONS");

print "<script language=javascript>\n";
print "<!--\n";

print "  function OpenandClose()\n";
print "   {\n";
print "    msgWindow=window.open(\"\",\"displayWindow\");\n";
print "    msgWindow.close();\n";
print "    window.open('/downloads/tmp/$random.html','msg','width=400,height=350,toolbar=no,resizable=yes,scrollbars=yes');\n";
print "   }\n";

print "  function UploadClose()\n";
print "   {\n";
print "    msgWindow=window.open(\"\",\"displayWindow\");\n";
print "    msgWindow.close();\n";
print "   }\n";

print "function selectall(dowhat,chkname)\n";
print "  {\n";
print "   var i;\n";
print "   for (i=0; document.wf_list.elements[i]; i++)\n";
print "    {\n";
print "     if (document.wf_list.elements[i].type == \"checkbox\" && document.wf_list.elements[i].name.substr(0,chkname.length) == chkname)\n";
print "      {\n";
print "        document.wf_list.elements[i].checked = dowhat;\n";
print "      }\n";
print "    }\n";
print "  }\n";

print "function doit(chkval,dowhat)\n";
print "  {\n";
print "   selectall(false,'chk_f');\n";
print "   var i;\n";
print "   for (i=0; document.wf_list.elements[i]; i++)\n";
print "    {\n";
print "     if (document.wf_list.elements[i].type == \"checkbox\" && document.wf_list.elements[i].value == chkval)\n";
print "      {\n";
print "        document.wf_list.elements[i].checked = true;\n";
print "        list_check(dowhat);\n";
print "      }\n";
print "    }\n";
print "  }\n";

print "function doiterr(chkval,dowhat)\n";
print "  {\n";
print "    alert(\"Please limit download file sizes to 5 MB.\");\n";
print "  }\n";

print "// -->\n";
print "</script>";

#- print heading

print "<form name=wf_list action=/cgi-bin/smoothftp/wf_list_handler.cgi method=post>";

print "<table width=\"100%\">";

if(length($FORM{filter}) > 0)
 {
  if(substr($FORM{filter},0,1) eq "*")
   {$filtext = "Only filenames ending with " . substr($FORM{filter},1,length($FORM{filter})-1);}

  if(substr($FORM{filter},length($FORM{filter})-1,1) eq "*")
   {$filtext = "Only filenames beginning with " . substr($FORM{filter},0,length($FORM{filter})-1);}

  print "<tr><td colspan=2 align=center class=messages>Filter: $filtext <span class=boldlink>[<a href=/cgi-bin/smoothftp/wf_nofilter.cgi?cwd=$cwd>Clear filter</a>]</span></td></tr>";
 }

if(length($FORM{msgok}) > 0)
 {
  print "<tr><td colspan=2 align=center class=messages>Last message: $FORM{msgok} successful.</td></tr>";
 }

if(length($FORM{msgcancel}) > 0)
 {
  print "<tr><td colspan=2 align=center class=messages>Last message: $FORM{msgcancel} cancelled.</td></tr>";
 }

$show_entries = $FORM{entries_per_page};

$nopages = 1;

if(($#name+1) > $show_entries)
 {
  $nopages = ($#name+1) / $show_entries;
  $nopages = sprintf "%3f",$nopages;
  $nopages++ if(int($nopages) != $nopages);
 }

print "<tr>";
print "<td align=left>";
print "<span class=tbright>Action: <span class=boldlink>";
print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&actionstyle=text>" if($action_style eq "pics");
print "text";
print "</a>" if($action_style eq "pics");
print "<font class=tbright>&nbsp;|&nbsp;</font>";
print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&actionstyle=pics>" if($action_style ne "pics");
print "icons";
print "</a>" if($action_style ne "pics");
print "</span>&nbsp; <font class=tbright>Listing: <span class=boldlink>";
print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&dirstyle=short>" if($dir_style ne "short");
print "short";
print "</a>" if($dir_style ne "short");
print "<font class=tbright>&nbsp;|&nbsp;</font>";
print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&dirstyle=long>" if($dir_style eq "short");
print "long";
print "</a>" if($dir_style eq "short");
print "</span></span></td>";

if($nopages > 1)
 {
  print "<td align=right><span class=tbright>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&page=999999>" if($page != 999999);
  print "<span class=boldlink>Single page";
  print "</a>" if($page != 999999);
  print "&nbsp; | &nbsp;";
  print "</span>Page: <span class=boldlink>";
  for($pg = 1;$pg <= $nopages;$pg++)
   {
    print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&page=$pg>" unless ($pg == $page);
    print "0" if($pg <= 9);
    print "$pg";
    print "</a>" unless ($pg == $page);
    print "&nbsp;";
   }
  print "</span></span></td>";
 }
else
  {print "<td>&nbsp;</td>";}

print "</tr>";

print "<tr><td align=left><span class=tbright>Current: </span><span class=boldlink>$url_string</span></td>";
print "<td align=right>";
print "<span class=tbright>Select all:&nbsp;</span><span class=boldlink>";
print "<a href=javascript:selectall(true,\'chk_file\')><span class=tbright>files</span></a>";
print "<span class=tbright>&nbsp;|&nbsp;</span>";
print "<a href=javascript:selectall(true,\'chk_folder\')><span class=tbright>dirs</span></a>";
print "&nbsp;</span><span class=tbright>Clear all:&nbsp;</span><span class=boldlink>";
print "<a href=javascript:selectall(false,\'chk_file\')><span class=tbright>files</span></a>";
print "<span class=tbright>&nbsp;|&nbsp;</span>";
print "<a href=javascript:selectall(false,\'chk_folder\')><span class=tbright>dirs</span></a>";
print "</span></td></tr>";

print "</table>";

print "<table width=\"100%\" border=0 cellspacing=1 cellpadding=1>";
print "<tr>";
print "<td class=darkshadebold>&nbsp;</td>";
print "<td class=darkshadebold>Name</td>";
print "<td class=darkshadebold align=center>Action</td>";
print "<td class=darkshadebold align=right>Size&nbsp;</td>";
print "<td class=darkshadebold>Timestamp</td>";
if($dir_style eq "long")
 {
  print "<td class=darkshadebold>User</td>";
  print "<td class=darkshadebold>Group</td>";
  print "<td class=darkshadebold>Attributes</td>";
 }
print "</tr>";

#- up one level ?

$toggle = 0;

if(($cwd ne $home_dir) and ($cwd ne "/"))
 {
  print "<tr>";
  print "<td class=lightline>&nbsp;</td>";
  print "<td class=lightline colspan=7 align=left>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&action=cdup&page=1><span class=boldlink>Up to parent</span></a></td>";
  print "</tr>";
  $toggle = 1;
 }

#- print body

$startrow = ($page - 1) * $show_entries;
$endrow = $startrow + ($show_entries-1);

$found_dirs = 0;
$found_files = 0;
$total_size = 0;
$found_all = 0;

for($two_loops = 0;$two_loops <= 1;$two_loops++)
 {
 for($i = 0;$i <= $#name;$i++)
  {
   if(substr($name[$i],0,1) ne "." and $name[$i] ne "")  ## file not hidden & name not empty
    {
     $show = 0;
     if($two_loops == 0) ## show directories in first loop
      {if(substr($attrib[$i],0,1) eq "d")
       {$show = 1;}
      }
     if($two_loops == 1) ## show files in second loop
      {if(substr($attrib[$i],0,1) ne "d")
       {$show = 1;}
      }

     if($show == 1)
      {
       if($page != 999999)
        {$show = 0 unless($show == 1 and $found_all >= $startrow and $found_all <= $endrow);}
        $found_all++;
      }

     if($show == 1)
      {
       if($toggle == 1)
        {$bgcol = "darkline";$toggle = 0;}
       else
        {$bgcol = "lightline";$toggle = 1;}

       if($is_link[$i] == 1)
        {$fp = "";}
       else
        {$fp = "$fullpath/";}

       if(substr($attrib[$i],0,1) ne "d")
        {
         $total_size += $size[$i];
         $icon = "/images/file.gif";
         $chkboxname = "chk_file";
         $modename = "fmode";
         $sz = $size[$i];
         $sz_kb = 0;
         $sz_mb = 0;
         if($sz > 1024)
          {
           $sz_kb = $sz / 1024;
           if($sz_kb > 1024)
            {$sz_mb = $sz_kb / 1024;
             $sz = sprintf("%7.2f",$sz_mb) . " mb";}
           else
            {$sz = sprintf("%d",$sz_kb) . " kb";}
          }
         else
          {$sz = sprintf("%d",$sz);}
        }
       else
        {
         $icon = "/images/folder.gif";
         $chkboxname = "chk_folder";
         $modename = "dmode";
        }

       if($is_link[$i] == 1)
         {
          if(substr($attrib[$i],0,1) eq "d")
            {$icon = "/images/link_folder.gif";}
          else
            {$icon = "/images/link.gif";}
         }

       print "<tr>";
       print "<td class=$bgcol align=right>";
       print "<input type=checkbox name=$chkboxname value=\"$name[$i]\">";
       print "<input type=hidden name=$modename value=\"$name[$i]~$attrib[$i]\">";
       print "<td class=$bgcol valign=center>";
       print "<img src=$icon width=13 height=12>&nbsp;";
       if(substr($actual_attrib[$i],0,1) eq "d")
        {print "<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$fp$name[$i]&page=1\">";}
       print "$name[$i]";
       if(substr($attrib[$i],0,1) eq "l")
        {print " -> $actual_name[$i]";}
       if(substr($actual_attrib[$i],0,1) eq "d")
        {print "</a>";}
       print "</td>";

       print "<td class=$bgcol align=center>";
       if($action_style eq "pics")
        {
#         if($sz_mb <= 5)
           {print "<a href=javascript:doit(\'$name[$i]\',\'download\')><img border=0 src=/images/download.gif width=13 height=12 alt=\"Download $name[$i]\"></a>";}
#         else
#           {print "<a href=javascript:doiterr(\'$name[$i]\',\'download\')><img border=0 src=/images/download.gif width=13 height=12 alt=\"Download $name[$i]\"></a>";}
         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'rename\')><img border=0 src=/images/rename.gif width=13 height=12 alt=\"Rename $name[$i]\"></a>";
         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'delete\')><img border=0 src=/images/delete.gif width=13 height=12 alt=\"Delete $name[$i]\"></a>";
         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'chmod\')><img border=0 src=/images/chmod.gif width=13 height=12 alt=\"Chmod $name[$i]\"></a>";
        }
       if($action_style eq "text")
        {
#         if($sz_mb <= 5)
           {print "<a href=javascript:doit(\'$name[$i]\',\'download\')>download</a>";}
#         else
#           {print "<a href=javascript:doiterr(\'$name[$i]\',\'download\')>download</a>";}

         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'rename\')>rename</a>";
         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'delete\')>delete</a>";
         print "&nbsp;&nbsp;&nbsp;";
         print "<a href=javascript:doit(\'$name[$i]\',\'chmod\')>chmod</a>";
        }
       print "</td>";

       print "<td class=$bgcol align=right>";
       if(substr($attrib[$i],0,1) ne "d")
        {print "$sz";}
       print "&nbsp;";
       print "</td>";

       print "<td class=$bgcol>$date[$i]</td>";
       if($dir_style eq "long")
        {
         print "<td class=$bgcol>$user[$i]</td>";
         print "<td class=$bgcol>$group[$i]</td>";
         print "<td class=$bgcol>$attrib[$i]</td>";
        }
       print "</tr>";

       if(substr($attrib[$i],0,1) eq "d")
        {$found_dirs++;}
       else
        {$found_files++;}
      }
    }
   }
 }

#- up one level ?

if(($found_files + $found_dirs >= 5) and ($cwd ne $home_dir) and ($cwd ne "/"))
 {
  if($toggle == 1)
   {$bgcol = "darkline";}
  else
   {$bgcol = "lightline";}

  print "<tr>";
  print "<td class=$bgcol>&nbsp;</td>";
  print "<td class=$bgcol colspan=7 align=left>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&action=cdup&page=1><span class=boldlink>Up to parent</span></a></td>";
  print "</tr>";
 }

#- print footing

if($total_size > 1024)
  {
   $size_kb = $total_size / 1024;
   if($size_kb > 1024)
    {$size_mb = $size_kb / 1024;
     $total_size = sprintf("%7.2f",$size_mb) . " mb";}
   else
    {$total_size = sprintf("%d",$size_kb) . " kb";}
  }
else
  {$total_size = sprintf("%d bytes",$size);}

print "<tr>";
print "<td class=darkshade>&nbsp;</td>";
print "<td class=darkshadebold colspan=7>";
print "$found_files files $found_dirs directories, total $total_size on this page</font></td>";
print "</tr>";

print "</table>";

if($found_files + $found_dirs > 15)
 {
  print "<table width=\"100%\">";

  print "<tr><td align=left><span class=tbright>Current: </span><span class=boldlink>$url_string</span></td>";
  print "<td align=right>";
  print "<span class=tbright>Select all:&nbsp;</span><span class=boldlink>";
  print "<a href=javascript:selectall(true,\'chk_file\')><span class=tbright>files</span></a>";
  print "<span class=tbright>&nbsp;|&nbsp;</span>";
  print "<a href=javascript:selectall(true,\'chk_folder\')><span class=tbright>dirs</span></a>";
  print "&nbsp;</span><span class=tbright>Clear all:&nbsp;</span><span class=boldlink>";
  print "<a href=javascript:selectall(false,\'chk_file\')><span class=tbright>files</span></a>";
  print "<span class=tbright>&nbsp;|&nbsp;</span>";
  print "<a href=javascript:selectall(false,\'chk_folder\')><span class=tbright>dirs</span></a>";
  print "</span></td></tr>";

  print "<tr>";
  print "<td align=left>";
  print "<span class=tbright>Action: <span class=boldlink>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&actionstyle=text>" if($action_style eq "pics");
  print "text";
  print "</a>" if($action_style eq "pics");
  print "<font class=tbright>&nbsp;|&nbsp;</font>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&actionstyle=pics>" if($action_style ne "pics");
  print "icons";
  print "</a>" if($action_style ne "pics");
  print "</span>&nbsp; <font class=tbright>Listing: <span class=boldlink>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&dirstyle=short>" if($dir_style ne "short");
  print "short";
  print "</a>" if($dir_style ne "short");
  print "<font class=tbright>&nbsp;|&nbsp;</font>";
  print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&dirstyle=long>" if($dir_style eq "short");
  print "long";
  print "</a>" if($dir_style eq "short");
  print "</span></span></td>";

  if($nopages > 1)
   {
    print "<td align=right><span class=tbright>";
    print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&page=999999>" if($page != 999999);
    print "<span class=boldlink>Single page";
    print "</a>" if($page != 999999);
    print "&nbsp; | &nbsp;";
    print "</span>Page: <span class=boldlink>";
    for($pg = 1;$pg <= $nopages;$pg++)
     {
      print "<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$cwd&page=$pg>" unless ($pg == $page);
      print "0" if($pg <= 9);
      print "$pg";
      print "</a>" unless ($pg == $page);
      print "&nbsp;";
     }
    print "</span></span></td>";
   }
  else
    {print "<td>&nbsp;</td>";}

  print "</tr>";

  if(length($FORM{filter}) > 0)
   {
    print "<tr><td colspan=2 align=center class=messages>Filter: $filtext <span class=boldlink>[<a href=/cgi-bin/smoothftp/wf_nofilter.cgi?cwd=$cwd>Clear filter</a>]</span></td></tr>";
   }

  if(length($FORM{msgok}) > 0)
   {
    print "<tr><td colspan=2 align=center class=messages>Last message: $FORM{msgok} successful.</td></tr>";
   }

  if(length($FORM{msgcancel}) > 0)
   {
    print "<tr><td colspan=2 align=center class=messages>Last message: $FORM{msgcancel} cancelled.</td></tr>";
   }
  print "</table>";
 }

print "<input type=hidden name=action value=none>";
print "<input type=hidden name=cwd value=$cwd>";
print "</form>";

#print "nopges=$nopages<br>dirlength=" . ($#name+1) . "<br>form=". ($#name+1) / $show_entries;
#print "<br>rem=". ($#name+1) % $show_entries;

&wf_print_toolbar($cwd,$home_dir,"TEXT");
&wf_print_footer("1");

#--- end
