#!/usr/bin/perl

sub read_config
 {
  @d = localtime;

#  print "Yr  : $d[5]\n";
#  print "Mo  : $d[4]\n";
#  print "Da  : $d[3]\n";

#  if($d[5] >= 103)
#    {
#     $FORM{servername}="x.x.x.x";
#     print "Content-type: text/html\n\n";
#     print "This beta evaluation copy of SmoothFTP has expired.<br>";
#     print "Please contact support\@smoothftp.com for a new copy.<br><br>";
#     die;
#    }

### defaults
  $FORM{smoothftp_home}="/usr/home/smoothftp_com";
  $FORM{download_dir}="/usr/home/smoothftp_com/downloads";
  $FORM{download_temp_dir}="/usr/home/smoothftp_com/downloads/tmp";
  $FORM{upload_dir}="/usr/home/smoothftp_com/uploads";
  $FORM{upload_temp_dir}="/usr/home/smoothftp_com/uploads/tmp";
  $FORM{cmd_rm}="/bin/rm";
  $FORM{cmd_rm_force_dir}="/bin/rm -rf";
  $FORM{cmd_echo}="/bin/echo";
  $FORM{cmd_md}="/bin/mkdir";
  $FORM{cmd_cat}="/bin/cat";
  $FORM{cmd_cleanup}="/usr/bin/at now + 3 hours";
  $FORM{cmd_zip_recursive}="/usr/home/smoothftp_com/bin/zip -r";
  $FORM{cmd_zip_make_sfx}="/usr/home/smoothftp_com/bin/zip -A";
  $FORM{cmd_unzip}="/usr/home/smoothftp_com/bin/unzip";
  $FORM{cmd_unzip_switches}="-a -n -qq";
  $FORM{cmd_unzip_switches_2}="-d";
  $FORM{cmd_zip_ignore_dir_struct}="-j";
  $FORM{unzip_sfx_location}="/usr/home/smoothftp_com/bin";
  $FORM{entries_per_page}=25;
  $FORM{download_popup_height}=150;
  $FORM{download_popup_width}=300;
  $FORM{upload_popup_height}=150;
  $FORM{upload_popup_width}=300;
  $FORM{bye_url} = "/";

  $FORM{top_banner_url} = "";
  $FORM{bottom_banner_url} = "";
  $FORM{bottom_text} = "";

### read from config file

  open(IN,"< ./smoothftp.config");
  while(<IN>)
   {
    chomp;
    $b = $_;
    if(substr($b,0,1) ne "#")
     {
      ($key, $val) = split(/=/, $b);

      $key =~ s/^\s*//;
      $val =~ s/^\s*//;

      $key =~ s/\s*$//;
      $val =~ s/\s*$//;

      if($key ne "" and $val ne "")
       {
        $FORM{$key}=$val; 
       }
     }
   }
  close(IN);

  open(IN,"< $FORM{smoothftp_home}/header.html");
  while(<IN>)
   {
    $FORM{top_banner_url} = $FORM{top_banner_url} . $_;
   }
  close(IN);

  open(IN,"< $FORM{smoothftp_home}/footer.html");
  while(<IN>)
   {
    $FORM{bottom_banner_url} = $FORM{bottom_banner_url} . $_;
   }
  close(IN);

  $FORM{servername}="";

  return;
 }

1;

