#!/usr/bin/perl

use Net::FTP;
require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";
require "redirect.cgi";
require "get_recursive.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$fcount = -1;
$madder = -1;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "name")
   {$FILES[++$fcount] = $value;
    $FTYPES[$fcount] = "F";
   }
  elsif($name eq "dname")
   {
    $FILES[++$fcount] = $value;
    $FTYPES[$fcount] = "D";
    $NDIRS[++$madder] = $value;
   }
  else
   {$FORM{$name} = $value;}
 }

#--- read cookies

&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";}

if($fcount < 0)
  {$error = 1;$errmsg = "NAME cannot be empty";}

$found_errors = 0;

if($FORM{cancel} eq "")
 {
  if($error != 0)
    {&wf_print_message($errmsg,$FORM{servername},$FORM{user_id});exit;}

  $ftp = &wf_connect();
  $ftp->cwd($FORM{cwd});
  &get_recursive();
  $ftp->cwd($FORM{cwd});

  for($i = 0,$k = 0;$i <= $#FILES;$i++)
   {
    if($FTYPES[$i] ne "D")
     {
      $ftp->delete($FILES[$i]);
      $delmsg[$k] = $ftp->code . " " . $ftp->message;
      if($ftp->ok)
       {$upokay[$k] = 1;}
      else
       {$upokay[$k] = 0; $found_errors = 1;}
      $fn[$k++] = "<img src=/images/file.gif height=12 width=13>&nbsp;$FILES[$i]";
     }
   }

  for($i = $#NDIRS;$i >= 0;$i--)
   {
    $entry = $NDIRS[$i];
    $ftp->rmdir($entry);
    $fn[$k] = "<img src=/images/folder.gif height=12 width=13>&nbsp;$entry";
    $delmsg[$k] = $ftp->code . " " . $ftp->message;
    if($ftp->ok)
     {$upokay[$k] = 1;}
    else
     {$upokay[$k] = 0; $found_errors = 1;}
    $k++;
   }

  $ftp->quit;

  if($found_errors == 1)
    {
    &wf_print_header("SmoothFTP > Delete",$FORM{servername},"<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\">$FORM{cwd}</a>","$FORM{user_id}");

    print "<p align=center><strong><font color=#0080C0 size=4>Delete Messages</font></strong></p>";

    print "<p align=center><b><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\">Continue</a></b></p>";

    print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

    print "<tr>";
    print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
    print "<td bgcolor=#EEEEEE><strong>Message</strong></td>";
    print "</tr>";

    for($i = 0;$i <= $#fn;$i++)
     {
      $fs = "";
      $fe = "";

      $fs = "<font color=red>" if($upokay[$i] ne 1);
      $fe = "</font>" if($upokay[$i] ne 1);

      print "<tr>";
      print "<td>$fn[$i]</td>";
      print "<td>$fs $delmsg[$i] $fe</td>";
      print "</tr>";
     }

    print "</table>";

    print "<br><p align=center><b><a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\">Continue</a></b></p>";

    &wf_print_footer(1);
   }
  else
   {
    &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}&msgok=Delete");
   }
 }
else
 {
  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}");
 }

#--- end
