#!/usr/bin/perl

use Net::FTP;
use CGI qw/:standard/;
use DBI;

require "wf_read_cookie_data.cgi";
require "wf_print_message.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "wf_connect.cgi";
require "get_recursive_local.cgi";
require "redirect.cgi";

#--- read cookie values

&wf_read_cookie_data();

@cookies = split("; ",$ENV{'HTTP_COOKIE'});

$FORM{smoothftp_user} = "-1";

for($i = 0;$i <= $#cookies;$i++)
 {
  ($cookie,$value) = split("=",$cookies[$i]);
    if($cookie eq "SMOOTHFTP_USR")
     {$FORM{smoothftp_user} = $value;}
    if($cookie eq "SMOOTHFTP_REM")
     {$FORM{smoothftp_rem} = $value;}
 }

$random = rand 65365;
$random = "tmp/" . $random;
system("/bin/mkdir /home/websites/smoothftp_com/uploads/$random");
system("/bin/echo rm -rf /home/websites/smoothftp_com/uploads/$random | /usr/bin/at now + 3 hours");

$mdcd = "";
$mdcd = param('dirname') if param('where') eq "cd";
$CGI_FORM{cwd} = param('dirname') if param('where') eq "cd";
$CGI_FORM{cwd} = param('cwd') unless param('where') eq "cd";

$CGI_FORM{total} = param('total');
$CGI_FORM{nofiles} = param('nofiles');

$overwrite = param('force');
$zipdirs = "-j" if(param('zipdirs') ne "on");

if($CGI_FORM{cwd} eq "")
  {&wf_print_message("CWD cannot be empty",$FORM{servername},$FORM{user_id},"");exit;}

#if($CGI_FORM{total} == -99)
# {
#  &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}");
#  exit;
# }

if($CGI_FORM{total} <= 0)
  {&wf_print_message("TOTAL cannot be zero",$FORM{servername},$FORM{user_id},"");exit;}

$k = 0;

$totupload = 0;

$tmpfile = upload('zipfile');
if($tmpfile)
 {
  if($FORM{smoothftp_user} eq "-1")
   {
    if(-s $tmpfile > 5120)
    {
     &wf_print_message("Please limit ZIP file sizes to 5 KB or <a 
href=/cgi-bin/secure/wf_signup.cgi>Signup</a> for Paid service",$FORM{servername},$FORM{user_id},"");
     exit;
    }
   }

  if(-s $tmpfile < 1)
   {
    &wf_print_message("SmoothFTP server is currently out of disk 
space.<br> We apologize for the inconvenience. Please try again later." 
. (-s $tmpfile),$FORM{servername},$FORM{user_id},"");
    exit;
   }

  $totupload += -s $tmpfile;

  $rando = rand 65365;
  system("/bin/mkdir /home/websites/smoothftp_com/uploads/$random/$rando");

  open NEW,"> /home/websites/smoothftp_com/uploads/$random/$rando/upload.zip";
  while(read($tmpfile,$buffer,1024))
   {print NEW $buffer;}
  close NEW;

  if(-s "/home/websites/smoothftp_com/uploads/$random/$rando/upload.zip" < 1)
  {
#   &wf_print_message("Out of disk space.",$FORM{servername},$FORM{user_id},"onLoad=\"UploadClose();\"");
   &wf_print_message("SmoothFTP server is currently out of disk space.<br> We apologize for the inconvenience. Please try again later.",$FORM{servername},$FORM{user_id},"");

   exit;
  }

  system("/home/websites/smoothftp_com/bin/unzip $zipdirs -a -n -qq /home/websites/smoothftp_com/uploads/$random/$rando/upload.zip -d /home/websites/smoothftp_com/uploads/$random/$rando");
  system("/bin/rm /home/websites/smoothftp_com/uploads/$random/$rando/upload.zip");

  &get_recursive_local("/home/websites/smoothftp_com/uploads/$random/$rando");
  $k = $#file_list + 1;

#  exit;
 }

#  print "Content-type: text/plain\n\n";

for($i = 0;$i < $CGI_FORM{total};$i++)
 {
  $tmpfile = upload('file'.$i);
  if($tmpfile)
   {
    if($FORM{smoothftp_user} eq "-1")
     {
      if(-s $tmpfile > 5120)
       {
        &wf_print_message("Please limit file sizes to 5 KB or <a 
href=/cgi-bin/secure/wf_signup.cgi>Signup</a> for Paid service",$FORM{servername},$FORM{user_id},"");
        exit;
       }
     }
    if(-s $tmpfile < 1)
     {
#      &wf_print_message("Out of disk space.",$FORM{servername},$FORM{user_id},"onLoad=\"UploadClose();\"");
    &wf_print_message("SmoothFTP server is currently out of disk 
space.<br> We apologize for the inconvenience. Please try again later." 
. (-s $tmpfile),$FORM{servername},$FORM{user_id},"");
      exit;
     }

    $totupload += -s $tmpfile;
    
    if(param("type$i") eq "detect")
     {$file_type[$k] = "D";}
    if(param("type$i") eq "ascii")
     {$file_type[$k] = "A";}
    if(param("type$i") eq "binary")
     {$file_type[$k] = "B";}

    if(index($tmpfile,"/") > 0)
     {
      @nm = split "/",$tmpfile;
      $localnm = $nm[$#nm];
     }

    if(index($tmpfile,"\\") > 0)
     {
      @nm = split /\\/,$tmpfile;
      $localnm = $nm[$#nm];
     }

#    $localnm =~ tr [ ] [_];

    $file_list[$k] = "/home/websites/smoothftp_com/uploads/$random/$localnm";
    $file_name[$k] = $localnm;
    $k++;

    open NEW,"> /home/websites/smoothftp_com/uploads/$random/$localnm";
    while(read($tmpfile,$buffer,1024))
     {print NEW $buffer;}
    close NEW;

    if(-s "/home/websites/smoothftp_com/uploads/$random/$localnm" < 1)
     {
#      &wf_print_message("Out of disk space.",$FORM{servername},$FORM{user_id},"onLoad=\"UploadClose();\"");
    &wf_print_message("SmoothFTP server is currently out of disk space.<br> We apologize for the inconvenience. Please try again later.",$FORM{servername},$FORM{user_id},"");
      exit;
     }
   }
 }

#if(length($FORM{smoothftp_user}) le 2)
# {
#  if($totupload > 51200)
#    {
#     &wf_print_message("Please limit total upload file size to 50 KB",$FORM{servername},$FORM{user_id},"");
#     exit;
#    }
# }

$ftp = &wf_connect();
$ftp->cwd($CGI_FORM{cwd});

if(! $ftp->ok)
 {
  $oth = "Could not CD to $CGI_FORM{cwd}: " . $ftp->code . " " . $ftp->message . "<br><br>";
  $CGI_FORM{cwd} = param('cwd');
  $oth .= "<a href=\"/cgi-bin/smoothftp/wf_upload_get.cgi?cwd=$CGI_FORM{cwd}&files=$CGI_FORM{nofiles}\"><b>Upload more</b></a>&nbsp;|&nbsp;";
  $oth .= "<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}\"><b>Continue</b></a>";
  &wf_print_message($oth,$FORM{servername},$FORM{user_id},"");
  $ftp->disconnect;
  exit;
 }

if(param('where') eq 'md')
 {
  $ftp->mkdir(param('ndirname'),1);
  $msg = $ftp->code . " " . $ftp->message;
  if(substr($ftp->code,0,1) eq "5")
   {
    $oth = "Could not Create " . param('ndirname') . ": $msg<br><br>";
    $CGI_FORM{cwd} = param('cwd');
    $oth .= "<a href=\"/cgi-bin/smoothftp/wf_upload_get.cgi?cwd=$CGI_FORM{cwd}&files=$CGI_FORM{nofiles}\"><b>Upload more</b></a>&nbsp;|&nbsp;";
    $oth .= "<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}\"><b>Continue</b></a>";
    &wf_print_message($oth,$FORM{servername},$FORM{user_id},"");
    $ftp->disconnect;
    exit;
   }
  $CGI_FORM{cwd} = param('ndirname');
  $ftp->cwd($CGI_FORM{cwd});
  $mdcd = $CGI_FORM{cwd};

  if(! $ftp->ok)
   {
    $oth = "Could not CD to $CGI_FORM{cwd}: " . $ftp->code . " " . $ftp->message . "<br><br>";
    $CGI_FORM{cwd} = param('cwd');
    $oth .= "<a href=\"/cgi-bin/smoothftp/wf_upload_get.cgi?cwd=$CGI_FORM{cwd}&files=$CGI_FORM{nofiles}\"><b>Upload more</b></a>&nbsp;|&nbsp;";
    $oth .= "<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}\"><b>Continue</b></a>";
    &wf_print_message($oth,$FORM{servername},$FORM{user_id},"");
    $ftp->disconnect;
    exit;
   }
 }

#$db = DBI->connect("dbi:mysql:database=smoothftp","denish","ebilfadi75");

for($i = 0;$i <= $#file_list;$i++)
 {
  if($file_type[$i] eq "-")
   {
    $makeit = 1;

    if($ftp->mdtm($file_name[$i]) ne "") ## an entry by this name exists. is it a dir?
     {
      @tdir = $ftp->dir($file_name[$i]);
      @workbuff = split(" ",$tdir[0]);
      $attrib[$k] = $workbuff[0];
      $makeit = 0 if(substr($attrib[$k],0,1) eq "d");
     }
     
    if($makeit == 1)
     {
      $ftp->mkdir($file_name[$i],1);
      $file_size[$i] = "MKDIR";
      $file_type[$i] = "D";
      $uplmsg[$i] = $ftp->code . " " . $ftp->message;
     }
    $upokay[$i] = 1;
   }
  else
   {
    open(WORK,$file_list[$i]);
    @d = stat(WORK);
    $filesize = $d[7];
    if($file_type[$i] eq "D")
     {
      $mode = "";
      $exit = 0;
      while($exit == 0)
       {
        read(WORK,$buffer,1024);
        for($jj=0;$jj <= length($buffer);$jj++)
         {
          $substr = substr $buffer,$jj,1;
          $examine = ord $substr;
          if($examine == 0)
           {$exit = 1;}
          else
           {
            if(($examine >= 32 and $examine <= 126) or ($examine == 26 or $examine == 8 or $examine == 9 or $examine == 10 or $examine == 12 or $examine == 13))
             {$mode = "A";}
            else
             {$mode = "B";$jj=length($buffer)+1;}
           }
         }
        $exit = 1 if($mode eq "B");
       }
      $file_type[$i] = $mode;
     }
    close(WORK);

    if($file_type[$i] eq "A")
     {
       open(WORK,$file_list[$i]);
       @input = <WORK>;
       close(WORK);
       open(WORK,"> $file_list[$i]");
       for($xx = 0;$xx <= $#input;$xx++)
         {
          $outline = $input[$xx];
          $outline =~ s/\r\n/\n/g;
          print WORK $outline;
         }
       close(WORK);
     }

    if($file_type[$i] eq "A")
      {$ftp->ascii();}
    if($file_type[$i] eq "B")
      {$ftp->binary();}

    $doit = 1;
  
    $doit = 0 if($overwrite ne "on" and $ftp->size($file_name[$i]) > 0);

    if($doit == 1)
     {
      $upld_ok = 1;
      if(param('delbefore') eq "on")
       {
        $ftp->delete($file_name[$i]);
        if($ftp->ok)
         {$upld_ok = 1;}
        else
         {
          $upld_ok = 0;
          $msg = "SKIPPED. Unable to delete existing file. " . $ftp->message;
          $upokay[$i] = 0;
         }
       }

      if($upld_ok == 1)
       {
        $ftp->put($file_list[$i],$file_name[$i]);
        $msg = $ftp->code . " " . $ftp->message;

        @d = localtime;

#        $query = "insert into upload_traffic(timestamp,month,ftpserver,filename,filesize,localname,userid) values ('@d',$d[4],'$FORM{servername}','$CGI_FORM{cwd}/$file_name[$i]',$filesize,'$file_list[$i]','$FORM{user_id}')";
#        $db->do($query) or &wf_print_message($query . $db->errstr);
#        $db->do($query);

        if($ftp->ok)
         {$upokay[$i] = 1;}
        else
         {
          $upokay[$i] = 0;}
       }
     }
    else
     {
      $msg = "SKIPPED. Destination file already exists.";
      $upokay[$i] = 0;
     }

    if($filesize > 1024)
      {
       $size_kb = $filesize / 1024;
       if($size_kb > 1024)
        {$size_mb = $size_kb / 1024;
         $filesize = sprintf("%7.2f",$size_mb) . " mb";}
       else
        {$filesize = sprintf("%d",$size_kb) . " kb";}
      }
    else
      {$filesize = sprintf("%d bytes",$filesize);}

    $file_size[$i] = $filesize;

    $uplmsg[$i] = $msg;
  }
 }
$ftp->quit;
#$db->disconnect;

$found_errors = 0;

$found_errors = 1 if($#file_list < 0);

for($i = 0;$i <= $#file_list;$i++)
 {
   $found_errors = 1 if($upokay[$i] ne 1);
 }

if($found_errors == 1)
 {
  &wf_print_header("SmoothFTP > Upload confirmation",$FORM{servername},"<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=".param('cwd')."\">".param('cwd')."</a>","$FORM{user_id}",0,"");

  print "\n<script language=\"JavaScript\">\n";
  print "<!--- \n";
  print "  function UploadClose()\n";
  print "   {\n";
  print "    msgWindow=window.open(\"\",\"displayWindow\");\n";
  print "    msgWindow.close();\n";
  print "   }\n";
  print "//-->\n";
  print "</script>\n";

  print "<p align=center><strong><font color=#0080C0 size=4>Upload confirmation</font><br>";
  print "in $CGI_FORM{cwd}</strong></p>";

  if($#file_list < 0)
   {
    print "<center>No files uploaded (Maybe incorrect ZIP file format).</center>";
   }
  else
   {
    print "<table align=center width=\"100%\" border=0 cellspacing=1 cellpadding=3>";

    print "<tr>";
    print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
    print "<td bgcolor=#EEEEEE><strong>Message</strong></td>";
    print "</tr>";

    for($i = 0;$i <= $#file_list;$i++)
     {
    if($file_type[$i] ne "-")
     {
      $fs = "";
      $fe = "";

      $fs = "<font color=red>" if($upokay[$i] ne 1);
      $fe = "</font>" if($upokay[$i] ne 1);

      print "<tr>";
      print "<td><img src=/images/file.gif height=12 width=13>&nbsp;$file_name[$i] ($file_size[$i])</td>";
      print "<td>$fs $uplmsg[$i] $fe</td>";
      print "</tr>";
     }
   }

    print "</table>";
   }

  $CGI_FORM{cwd} = param('cwd');

  print "<br><p align=center>";
  print "<a href=\"/cgi-bin/smoothftp/wf_upload_get.cgi?cwd=$CGI_FORM{cwd}&files=$CGI_FORM{nofiles}\"><b>Upload more</b></a>&nbsp;|&nbsp;";
  print "<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}\"><b>Continue</b></a>";
  print "&nbsp;|&nbsp;<a href=\"/cgi-bin/smoothftp/wf_list.cgi?cd=$mdcd\"><b>Change to $mdcd</b></a>" if($mdcd ne "");
  print "</p>";

  &wf_print_footer("1");
 }
else
 {
    &redirect("/cgi-bin/smoothftp/wf_list.cgi?cd=$CGI_FORM{cwd}&msgok=Upload");
 }

#--- end
