#!/usr/bin/perl

use DBI;

require "wf_print_message.cgi";
require "../smoothftp/read_form_data.cgi";
require "../smoothftp/redirect.cgi";

&read_form_data();

$l = length $FORM{desired_user_name};

if($l > 14)
 {
  &wf_print_message("User-id cannot exceed 14 characters.");
  exit;
 }

for($i = 0;$i < $l;$i++)
 {
  $okay = 0;
  $uname = substr $FORM{desired_user_name},$i,1;
  $a = ord $uname;
  if($a >= 65 and $a <= 65+26){$okay = 1;}
  if($a >= 97 and $a <= 97+26){$okay = 1;}
  if($a >= 48 and $a <= 48+10){$okay = 1;}
  if($uname eq "_"){$okay = 1;}
  if($okay == 0)
    {
     &wf_print_message("<b>$FORM{desired_user_name}</b> : User-id can be made up of alphabets, numbers & underscore only.");
     exit;
    }
 }

$l = length $FORM{desired_user_password};
if ($l < 6)
  {
   &wf_print_message("Passwords must be atleast 6 characters. Please try again.");
   exit;
  }

if ($FORM{desired_user_password} ne $FORM{desired_user_password2})
  {
   &wf_print_message("Passwords don\'t match. Please try again.");
   exit;
  }

$l = length $FORM{user_email};
$em = "";
for($i = 0;$i < $l;$i++)
 {
  $ok = 0;
  $uname = substr $FORM{user_email},$i,1;
  $a = ord $uname;
  if (($a >= 65 and $a <= 65+26) or
     ($a >= 97 and $a <= 97+26) or
     ($a >= 48 and $a <= 48+10) or
     ($uname eq "-") or
     ($uname eq "_") or
     ($uname eq ".") or
     ($uname eq "\@")){$ok = 1;}
  if($ok == 1){$em = $em . $uname;}
 }

$FORM{user_email} = $em;

$l = length $FORM{user_email};
if ($l < 3)
  {
   &wf_print_message("$FORM{user_email} : E-mail address must be atleast 3 characters. Please try again.");
   exit;
  }

$okaya = 0;
$okayb = 0;
$okayc = 0;
for($i = 0;$i < $l;$i++)
 {
  $bad = 1;
  $uname = substr $FORM{user_email},$i,1;
  $a = ord $uname;
  if (($a >= 65 and $a <= 65+26) or
     ($a >= 97 and $a <= 97+26) or
     ($a >= 48 and $a <= 48+10) or
     ($uname eq "-") or
     ($uname eq "_") or
     ($uname eq ".")){$okaya = 1;$bad = 0;}
  if($uname eq "\@"){$okayb = 1;$bad = 0;}
  if($uname eq "."){$okayc = 1;$bad = 0;}
 }

if($okaya + $okayb + $okayc != 3)
 {
  &wf_print_message("<b>$FORM{user_email}</b> : E-mail addresses are made up of alphabets, numbers, underscores & dashes only.<br>And, are of the format <i>address\@domain.xxx</i>");
  exit;
 }

if($bad == 1)
 {
  &wf_print_message("<b>$FORM{user_email}</b> : E-mail addresses are made up of alphabets, numbers, underscores & dashes only.<br>And, are of the format <i>address\@domain.xxx</i>");
  exit;
 }

$dbh = DBI->connect("dbi:mysql:database=smoothftp","root","ebilfadi75");

$query = "select user_pk from users where user_id = '$FORM{desired_user_name}'";
$sth = $dbh->prepare($query) or die $query . $dbh->errstr;
$rh = $sth->execute or die $query . $dbh->errstr;
$sth->finish;

if($rh > 0)
 {
  $adder = 1;
  $found = 0;
  while(!$found)
   {
    $suggested_name = $FORM{desired_user_name} . $adder;
    $query = "select user_pk from users where user_id = \"$suggested_name\"";
    $sth = $dbh->prepare($query) or die $query . $dbh->errstr;
    $rh = $sth->execute or die $query . $dbh->errstr;
    $sth->finish;
    $adder += 1;
    if($rh == 0){$found = 1;}
   }
  $dbh->disconnect();
  &wf_print_message("This user-id is already taken. Please try with another one.<br>The next available is <b>$suggested_name</b>");
  exit;
 }

$FORM{desired_user_password} = crypt($FORM{desired_user_password},"A0[B1;C2#");
$query = "insert into users(user_id,user_passwd,user_email,user_fname,user_lname) values('$FORM{desired_user_name}','$FORM{desired_user_password}','$FORM{user_email}','$FORM{user_fname}','$FORM{user_lname}')";
$sth = $dbh->do($query) or die $query . $dbh->errstr;

$query = "select user_pk from users where user_id = '$FORM{desired_user_name}'";
$sth = $dbh->prepare($query) or die $query . $dbh->errstr;
$rh = $sth->execute or die $query . $dbh->errstr;
@row = $sth->fetchrow_array;
$sth->finish;

$user_no = $row[0];
$cgi = "/";

$dbh->disconnect();

open(MAIL,"| /usr/sbin/sendmail -t");

print MAIL "From: SmoothFTP <support\@smoothftp.com>\n";
print MAIL "To: $FORM{user_email}\n";
print MAIL "Subject: Welcome to SmoothFTP\n\n";

if(length($FORM{user_fname}) > 0)
 {
  print MAIL "Dear $FORM{user_fname},\n\n";
 }
else
 {
  print MAIL "Dear $FORM{desired_user_name},\n\n";
 }
print MAIL "Thank you for signing up with SmoothFTP.\n\n";

print MAIL "SmoothFTP aims to make file uploads & downloads a very simple & enjoyable\n";
print MAIL "experience for you.\n\n";
print MAIL "We welcome any suggestions/comments from you for improving SmoothFTP.\n\n";
print MAIL "You visit the SmoothFTP forum at http://forum.smoothftp.com and leave feedback.\n\n";

print MAIL "If you have not requested the above, or if you are not a SmoothFTP member\n";
print MAIL "we are sorry to intrude your privacy. We would appreciate if you could\n";
print MAIL "spend a few minutes & drop a mail to support\@smoothftp.com about this.\n";

print MAIL "__________________________________________________________________\n";
print MAIL "SmoothFTP - Browser based file transfers. http://www.smoothftp.com\n";

close(MAIL);

open(MAIL,"| /usr/sbin/sendmail -t");

print MAIL "From: support\@smoothftp.com\n";
print MAIL "To: denny\@denish.com\n";
print MAIL "Subject: New-user $FORM{desired_user_name} - $FORM{user_email}\n\n";

close(MAIL);

print "Set-Cookie: SMOOTHFTP_USR=$user_no; path=/;\n";
#&wf_print_message("$cgi");
&redirect($cgi);
