# listlib.pl - Directory listing subroutines
# This file is part of Syrine 0.1b
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

sub PrintLaunch { # Prints the list of "Launchable Links."

  print '<HTML><HEAD><TITLE> Syrine - Launchable Links </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> Syrine: Launchable Links: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {
    print '<P> Your command did not generate any output </P>',"\n";
  } else {
    &GetDirList(0);
    print '<P> The list below contains links to files and directories in your working',"\n",
    'directory. Clicking any of the "OPEN: [ * ]" links will send a list of',"\n",
    'launchable links for the corresponding directory. Clicking any of the',"\n",
    '"! LAUNCH: * " links will launch the corresponding file on ',"$HostName",'.',"\n",
    '</P><CENTER><H2><HR> Working Directory is: ',"$pwd\n",
    '</H2></CENTER><TABLE><TR><TD><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshlaunchlist+..">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/back.gif" ALIGN=left HSPACE=0 BORDER=0> OPEN:  [ .. ]</A></B></TD></TR>',"\n";
    foreach $i (0..$#dirarray) { 
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshlaunchlist+',"$ldirarray[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/menu.gif" ALIGN=left HSPACE=2 BORDER=0> OPEN:  [ ',"$dirarray[$i]",' ]</A></B></TD></TR>',"\n";
    }
    print '</TABLE><BR><TABLE>',"\n";
    &GetFileList(0);
    if ($Win32) {
      foreach $i (0..$#filearray) {
        print '<TR><TD NOWRAP><B>',"\n",
        '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshstart+%22',"$lfilearray[$i]",'%22">',"\n",
        '<IMG SRC="',"$SendFilesUrl",'/greenball.gif" HSPACE=4 BORDER=0> ! LAUNCH:  ',"$filearray[$i]",'</A></B></TD></TR>',"\n";
      };
    } else {
      foreach $i (0..$#filearray) {
        if (-x $filearray[$i] || -X _) {
          print '<TR><TD NOWRAP><B>',"\n",
          '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshstart+%22.%2F',"$lfilearray[$i]",'%22">',"\n",
          '<IMG SRC="',"$SendFilesUrl",'/greenball.gif" HSPACE=4 BORDER=0> ! LAUNCH:  ',"$filearray[$i]",'</A></B></TD></TR>',"\n";
        };
      };
    };
  };
  print '<TR><TD></TD></TR></TABLE>',"\n";
}

sub PrintExec { # Prints the list of "Executable Links."

  print '<HTML><HEAD><TITLE> Syrine - Executable Links </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> Syrine: Executable Links: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {
    print '<P> Your command did not generate any output </P>',"\n";
  } else {
    &GetDirList(0);
    print '<P> The list below contains links to executable files and to directories in your working',"\n",
    'directory. Clicking any of the "OPEN: [ * ]" links will send a list of',"\n",
    'executable links for the corresponding directory. Clicking any of the',"\n",
    '"! EXECUTE: * " links will execute the corresponding program on ',"$HostName",',',"\n",
    'wait for it to finish, and return its (text) output.',"\n",
    '</P><CENTER><H2><HR> Working Directory is: ',"$pwd\n",
    '</H2></CENTER><TABLE><TR><TD><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshexeclist+..">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/back.gif" ALIGN=left HSPACE=0 BORDER=0> OPEN:  [ .. ]</A></B></TD></TR>',"\n";
    foreach $i (0..$#dirarray) { 
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshexeclist+',"$ldirarray[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/menu.gif" ALIGN=left HSPACE=2 BORDER=0> OPEN:  [ ',"$dirarray[$i]",' ]</A></B></TD></TR>',"\n";
    };
    print '</TABLE><BR><TABLE>',"\n";
    &GetFileList(0);
    if ($Win32) {
      local($ext) = '';
      foreach $i (0..$#filearray) {
        $ext = &FileExt($filearray[$i]);
        if ($ext eq '.EXE' || $ext eq '.BAT' || ($ext eq '.CMD' && $OStype eq 'wNT')) {
          print '<TR><TD NOWRAP><B>',"\n",
          '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=%22%22',"$lfilearray[$i]",'%22%22">',"\n",
          '<IMG SRC="',"$SendFilesUrl",'/orangeball.gif" HSPACE=4 BORDER=0> ! EXECUTE:  ',"$filearray[$i]",'</A></B></TD></TR>',"\n";
        };
      };
    } else {
      foreach $i (0..$#filearray) {
        if (-x $filearray[$i] || -X _) {
          print '<TR><TD NOWRAP><B>',"\n",
          '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=%22.%2F',"$lfilearray[$i]",'%22">',"\n",
          '<IMG SRC="',"$SendFilesUrl",'/orangeball.gif" HSPACE=4 BORDER=0> ! EXECUTE:  ',"$filearray[$i]",'</A></B></TD></TR>',"\n";
        };
      };
    };
  };
  print '<TR><TD></TD></TR></TABLE>',"\n";
}

sub PrintGet { # Prints the list of "Downloadable Links."

  print '<HTML><HEAD><TITLE> Syrine - Downloadable Links </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> Syrine: Downloadable Links: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {
    print '<P> Your command did not generate any output </P>',"\n";
  } else {
    &GetDirList(0);
    print '<P> The list below contains links to files and directories in your working',"\n",
    'directory. Clicking any of the "OPEN: [ * ]" links will send a list of',"\n",
    'Downloadable links for the corresponding directory. Clicking any of the',"\n",
    '"GET: * " links will send the corresponding file with its appropriate MIME type reported.',"\n";
    if ($GetOptions =~ m/B/) {
      print ' "[GET as BIN]" will send it as a binary file';
      if ($GetOptions =~ m/T/) {print ', and';} else {print '.';};
    };
    if ($GetOptions =~ m/T/) {
      print ' "[GET as TEXT]" will send it as plain text.',"\n";
    };
    print '</P><CENTER><H2><HR> Working Directory is: ',"$pwd\n",
    '</H2></CENTER><TABLE><TR><TD><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgetlist+..">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/back.gif" ALIGN=left HSPACE=0 BORDER=0> OPEN:  [ .. ]</A></B></TD></TR>',"\n";
    foreach $i (0..$#dirarray) { 
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgetlist+',"$ldirarray[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/menu.gif" ALIGN=left HSPACE=2 BORDER=0> OPEN:  [ ',"$dirarray[$i]",' ]</A></B></TD></TR>',"\n";
    };
    print '</TABLE><BR><TABLE>',"\n";
    &GetFileList(0);
    foreach $i (0..$#filearray) {
      local($pathfn) = '';
      if ($XPath) {
        $pathfn = "/$lfilearray[$i]";
        $pathfn =~ s/\+/\_/g;
      };
      print '<TR><TD NOWRAP><B><IMG SRC="',"$SendFilesUrl",'/yellowball.gif" HSPACE=2>',"\n",
      '<A HREF="',"$ScriptUrl$pathfn",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshget+',"$lfilearray[$i]",'">',"\n",
      ' GET:  ',"$filearray[$i]",' </A>';
      if ($GetOptions =~ m/B/) {
        print '<IMG SRC="',"$SendFilesUrl",'/yellowball.gif" HSPACE=2>',"\n",
        '<A HREF="',"$ScriptUrl$pathfn",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgetbin+',"$lfilearray[$i]",'">',"\n",
        ' [GET as BIN] </A>';
      };
      if ($GetOptions =~ m/T/) {
        print '<IMG SRC="',"$SendFilesUrl",'/yellowball.gif" HSPACE=2>',"\n",
        '<A HREF="',"$ScriptUrl$pathfn",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgettxt+',"$lfilearray[$i]",'">',"\n",
        ' [GET as TEXT] </A>';
      };
      print '</B></TD></TR>',"\n";
    };
  };
  print '<TR><TD></TD></TR></TABLE>',"\n";
}

1; # return true
